'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash.values');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _Html = require('./Html');

var _Html2 = _interopRequireDefault(_Html);

var _HighlightSidebar = require('./HighlightSidebar');

var _HighlightSidebar2 = _interopRequireDefault(_HighlightSidebar);

var _Loading = require('./Loading');

var _Loading2 = _interopRequireDefault(_Loading);

var _loading = require('../reducers/loading');

var _transactions = require('../reducers/transactions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HYPOTHESIS_SEARCH_PATH = 'https://hypothes.is/api/search?url=';
var filterTags = ['ClimateFeedback'];

var HighlightHtml = function (_Component) {
  _inherits(HighlightHtml, _Component);

  function HighlightHtml() {
    _classCallCheck(this, HighlightHtml);

    var _this = _possibleConstructorReturn(this, (HighlightHtml.__proto__ || Object.getPrototypeOf(HighlightHtml)).call(this));

    _this.state = {
      highlightsCount: 0,
      intervalsCount: 0,
      highlights: null,
      warning: null
    };
    _this.handleSetAnnotations = _this._handleSetAnnotations.bind(_this);
    _this.handleSetAnnotationsCount = _this._handleSetAnnotationsCount.bind(_this);
    _this.handleSetHighlights = _this._handleSetHighlights.bind(_this);
    return _this;
  }

  _createClass(HighlightHtml, [{
    key: '_handleSetAnnotations',
    value: function _handleSetAnnotations() {
      var _this2 = this;

      var handleSetHighlights = this.handleSetHighlights;
      var _props = this.props,
          linkUrl = _props.linkUrl,
          showLoading = _props.showLoading;

      if (!linkUrl) {
        return;
      }
      this.setState({
        warning: 'Wait for annotations'
      });
      window.fetch('' + HYPOTHESIS_SEARCH_PATH + encodeURI(linkUrl)).then(function (result) {
        result.json().then(function (json) {
          _this2.handleSetHighlights(json.rows);
        });
      });
    }
  }, {
    key: '_handleSetAnnotationsCount',
    value: function _handleSetAnnotationsCount() {
      var countDivElement = this.countDivElement,
          handleSetAnnotations = this.handleSetAnnotations;
      var showLoading = this.props.showLoading;
      var highlightsCount = this.state.highlightsCount;

      if (countDivElement && highlightsCount !== countDivElement.textContent) {
        // update state
        this.setState({
          highlightsCount: countDivElement.textContent
        });
        // just wait a little bit because even if the
        // hyp count has changed, it does not have already now
        // added the span in the html content
        setTimeout(handleSetAnnotations, 100);
      }
    }
  }, {
    key: '_handleSetHighlights',
    value: function _handleSetHighlights(annotations) {
      var _props2 = this.props,
          closeLoading = _props2.closeLoading,
          filterTags = _props2.filterTags;
      // scrap hypothesis elements only in our container

      var elements = [].concat(_toConsumableArray(this.divElement.querySelectorAll('hypothesis-highlight')));
      // check that we got several of them
      if (elements.length === 0) {
        this.setState({
          warning: 'Wait for the hypothesis-highlight elements'
        });
        return;
      }
      // close loading
      closeLoading();
      // wait until we have the highlights from chrome and the
      // highlights from the apis
      // the list of highlights is normally higher than the highlights one
      // because for one highlighted text, you can have several highlights
      var anchoredAnnotationsById = {};
      var referedAnnotations = [];
      // filter the tags
      var filteredAnnotations = annotations && annotations.filter(function (_ref) {
        var tags = _ref.tags;
        return !filterTags.find(function (filterTag) {
          return !tags.includes(filterTag);
        });
      });
      // then set
      filteredAnnotations.forEach(function (annotation) {
        if (annotation.references) {
          referedAnnotations.push(annotation);
        } else {
          anchoredAnnotationsById[annotation.id] = annotation;
        }
      });
      referedAnnotations.forEach(function (referedAnnotation) {
        referedAnnotation.references.forEach(function (reference) {
          var anchoredAnnotation = anchoredAnnotationsById[reference];
          if (anchoredAnnotation) {
            if (typeof anchoredAnnotation.referedAnnotationsById === 'undefined') {
              anchoredAnnotation.referedAnnotationsById = {};
            }
            anchoredAnnotation.referedAnnotationsById[referedAnnotation.id] = referedAnnotation;
          }
        });
      });
      // set the highlights by finding the matching elements for each anchored annotation
      var anchoredAnnotations = (0, _lodash2.default)(anchoredAnnotationsById);
      var highlights = anchoredAnnotations.map(function (anchoredAnnotation, index) {
        var exactText = anchoredAnnotation.target && anchoredAnnotation.target[0] && anchoredAnnotation.target[0].selector && anchoredAnnotation.target[0].selector[3] && anchoredAnnotation.target[0].selector[3].exact;
        if (!exactText) {
          return;
        }
        var matchedElements = elements.filter(function (element) {
          return exactText.includes(element.textContent);
        });
        if (elements.length === 0) {
          return;
        }
        return {
          annotation: anchoredAnnotation,
          exactText: exactText,
          elements: matchedElements,
          // we shift of 50px to put the highlight button just over the top
          // baseline of the selection
          top: matchedElements[0].offsetTop - 40
        };
      }).filter(function (highlight) {
        return highlight;
      });
      // update count
      var highlightsCount = this.countDivElement.textContent;
      // set state
      this.setState({
        highlightsCount: highlightsCount,
        highlights: highlights,
        warning: null
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var countDivElement = this.countDivElement,
          handleSetAnnotationsCount = this.handleSetAnnotationsCount;
      var showLoading = this.props.showLoading;
      // add the hyp script

      var scriptElement = document.createElement('script');
      scriptElement.id = 'hypothesis_script';
      scriptElement.type = 'text/javascript';
      scriptElement.async = true;
      scriptElement.src = "https://hypothes.is/embed.js";
      this.divElement.appendChild(scriptElement);
      // loading
      showLoading();
      // update warning
      this.setState({
        warning: 'Wait for hypothesis'
      });
      // add the listener on annotation editing
      countDivElement.addEventListener('DOMNodeInserted', handleSetAnnotationsCount);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var countDivElement = this.countDivElement,
          handleSetAnnotationsCount = this.handleSetAnnotationsCount;
      // remove

      countDivElement.removeEventListener('DOMNodeInserted', handleSetAnnotationsCount);
      // remove the annotator plugin
      window.annotator && window.annotator.destroy();
      var linkElement = document.querySelector('link[href="https://hypothes.is/app.html"]');
      linkElement.parentElement.removeChild(linkElement);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props3 = this.props,
          articleId = _props3.articleId,
          className = _props3.className,
          __html = _props3.__html,
          isLoadingActive = _props3.isLoadingActive,
          linkId = _props3.linkId,
          linkUrl = _props3.linkUrl,
          slug = _props3.slug;
      var _state = this.state,
          highlights = _state.highlights,
          warning = _state.warning;

      var isHighlight = highlights && highlights.length > 0;
      return _react2.default.createElement(
        'div',
        {
          className: className || 'highlight-html',
          ref: function ref(_e) {
            return _this3.divElement = _e;
          }
        },
        linkUrl && _react2.default.createElement('link', { rel: 'canonical', href: linkUrl }),
        _react2.default.createElement(
          'div',
          { className: 'highlight-html__info' },
          _react2.default.createElement('div', {
            className: 'highlight-html__info__count',
            'data-hypothesis-annotation-count': true,
            ref: function ref(_e) {
              return _this3.countDivElement = _e;
            }
          }),
          _react2.default.createElement(
            'div',
            { className: 'highlight-html__info__loading' },
            isLoadingActive && _react2.default.createElement(_Loading2.default, null)
          ),
          _react2.default.createElement(
            _Button2.default,
            {
              className: (0, _classnames2.default)('button highlight-html__info__button', {
                'button--shadow button--alive': isHighlight && !warning,
                'highlight-html__info__button--disabled': !isHighlight || warning,
                'highlight-html__info__button--warning': warning
              }),
              onClick: function onClick() {
                if (!warning) {
                  document.querySelector('.annotator-bucket-indicator.lower').querySelector('.label').click();
                  return;
                }
              }
            },
            warning || 'Your claims are downloaded'
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'highlight-html__content' },
          _react2.default.createElement(_Html2.default, {
            __html: __html
          })
        ),
        _react2.default.createElement(_HighlightSidebar2.default, {
          articleId: articleId,
          highlights: highlights,
          linkId: linkId
        })
      );
    }
  }]);

  return HighlightHtml;
}(_react.Component);

HighlightHtml.defaultProps = {
  filterTags: filterTags,
  __html: ''
};

function mapStateToProps(_ref2) {
  var isActive = _ref2.loading.isActive;

  return {
    isLoadingActive: isActive
  };
}
exports.default = (0, _reactRedux.connect)(mapStateToProps, {
  closeLoading: _loading.closeLoading,
  showLoading: _loading.showLoading
})(HighlightHtml);